/*
 * dummy_guest.c
 *
 * Created: 6/23/2017 2:48:07 PM
 *  Author: Neil Klingensmith
 */ 

#include "serial.h" // Hermes
#define DUMMY_STACK_SIZE 1024

char dummy_stack[DUMMY_STACK_SIZE];


// dummy exception handler
void dummyHandler()
{
	//while(1);
}

int print_enable = 0;

void dummySysTickHandler(){
	print_enable++;
}

#define USART_SERIAL                     USART1

void print_string(char *str){
	
	while(*str != '\0'){
		usart_serial_putchar(USART_SERIAL, *str);
		str++;
	}
}

void dummy_guest()
{
	int i;
	
	while(1){
		//for(i = 0; i < 10000; i++); // Delay
	
		if(print_enable > 1000){
			print_enable = 0;
			print_string("\r\nDummy Guest\r\n");
		}
		
	}
	
	
}





extern unsigned long _estack;

void *dummyVectorTable[] __attribute__ ((aligned (128))) = {
	
	/* Configure Initial Stack Pointer, using linker-generated symbols */
	(void*) (void*) (&dummy_stack[DUMMY_STACK_SIZE-4]),    /* Initial stack pointer */ // HACK ALERT!!!! This is used to bypass attempt to load the initial stack pointer from the OS's vector table in prvPortStartFirstTask, found in port.c. Hack can be avoided by virtualizing the MSR instruction

	(void*) dummy_guest,    /* Reset Handler */
	(void*) dummyHandler,    /* NMI Handler */
	(void*) dummyHandler,    /* Hard Fault Handler */
	(void*) dummyHandler,    /* MemManage Handler */
	(void*) dummyHandler,    /* Bus Fault Manager */
	(void*) dummyHandler,    /* Usage Fault Handler */
	(void*) dummyHandler,    /* Reserved */
	(void*) dummyHandler,    /* Reserved */
	(void*) dummyHandler,    /* Reserved */
	(void*) dummyHandler,    /* Reserved */
	(void*) dummyHandler,    /* SVC Handler */
	(void*) dummyHandler,    /* Debug Mon Handler */
	(void*) dummyHandler,    /* Reserved */
	(void*) dummyHandler,    /* PendSV Handler */
	(void*) dummySysTickHandler,    /* SysTick Handler */

	/* Configurable interrupts */
	(void*) dummyHandler,    /* 0  Supply Controller */
	(void*) dummyHandler,    /* 1  Reset Controller */
	(void*) dummyHandler,    /* 2  Real Time Clock */
	(void*) dummyHandler,    /* 3  Real Time Timer */
	(void*) dummyHandler,    /* 4  Watchdog Timer */
	(void*) dummyHandler,    /* 5  Power Management Controller */
	(void*) dummyHandler,    /* 6  Enhanced Embedded Flash Controller */
	(void*) dummyHandler,    /* 7  UART 0 */
	(void*) dummyHandler,    /* 8  UART 1 */
	(void*) dummyHandler,    /* 9  Reserved */
	(void*) dummyHandler,    /* 10 Parallel I/O Controller A */
	(void*) dummyHandler,    /* 11 Parallel I/O Controller B */
	(void*) dummyHandler,    /* 12 Parallel I/O Controller C */
	(void*) dummyHandler,    /* 13 USART 0 */
	(void*) dummyHandler,    /* 14 USART 1 */
	(void*) dummyHandler,    /* 15 USART 2 */
	(void*) dummyHandler,    /* 16 Parallel I/O Controller D */
	(void*) dummyHandler,    /* 17 Parallel I/O Controller E */
	(void*) dummyHandler,    /* 18 Multimedia Card Interface */
	(void*) dummyHandler,    /* 19 Two Wire Interface 0 HS */
	(void*) dummyHandler,    /* 20 Two Wire Interface 1 HS */
	(void*) dummyHandler,    /* 21 Serial Peripheral Interface 0 */
	(void*) dummyHandler,    /* 22 Synchronous Serial Controller */
	(void*) dummyHandler,    /* 23 Timer/Counter 0 */
	(void*) dummyHandler,    /* 24 Timer/Counter 1 */
	(void*) dummyHandler,    /* 25 Timer/Counter 2 */
	(void*) dummyHandler,    /* 26 Timer/Counter 3 */
	(void*) dummyHandler,    /* 27 Timer/Counter 4 */
	(void*) dummyHandler,    /* 28 Timer/Counter 5 */
	(void*) dummyHandler,    /* 29 Analog Front End 0 */
	(void*) dummyHandler,    /* 30 Digital To Analog Converter */
	(void*) dummyHandler,    /* 31 Pulse Width Modulation 0 */
	(void*) dummyHandler,    /* 32 Integrity Check Monitor */
	(void*) dummyHandler,    /* 33 Analog Comparator */
	(void*) dummyHandler,    /* 34 USB Host / Device Controller */
	(void*) dummyHandler,    /* 35 MCAN Controller 0 */
	(void*) dummyHandler,    /* 36 Reserved */
	(void*) dummyHandler,    /* 37 MCAN Controller 1 */
	(void*) dummyHandler,    /* 38 Reserved */
	(void*) dummyHandler,    /* 39 Ethernet MAC */
	(void*) dummyHandler,    /* 40 Analog Front End 1 */
	(void*) dummyHandler,    /* 41 Two Wire Interface 2 HS */
	(void*) dummyHandler,    /* 42 Serial Peripheral Interface 1 */
	(void*) dummyHandler,    /* 43 Quad I/O Serial Peripheral Interface */
	(void*) dummyHandler,    /* 44 UART 2 */
	(void*) dummyHandler,    /* 45 UART 3 */
	(void*) dummyHandler,    /* 46 UART 4 */
	(void*) dummyHandler,    /* 47 Timer/Counter 6 */
	(void*) dummyHandler,    /* 48 Timer/Counter 7 */
	(void*) dummyHandler,    /* 49 Timer/Counter 8 */
	(void*) dummyHandler,    /* 50 Timer/Counter 9 */
	(void*) dummyHandler,    /* 51 Timer/Counter 10 */
	(void*) dummyHandler,    /* 52 Timer/Counter 11 */
	(void*) dummyHandler,    /* 53 Reserved */
	(void*) dummyHandler,    /* 54 Reserved */
	(void*) dummyHandler,    /* 55 Reserved */
	(void*) dummyHandler,    /* 56 AES */
	(void*) dummyHandler,    /* 57 True Random Generator */
	(void*) dummyHandler,    /* 58 DMA */
	(void*) dummyHandler,    /* 59 Camera Interface */
	(void*) dummyHandler,    /* 60 Pulse Width Modulation 1 */
	(void*) dummyHandler,    /* 61 Reserved */
	(void*) dummyHandler,    /* 62 SDRAM Controller */
	(void*) dummyHandler     /* 63 Reinforced Secure Watchdog Timer */
};



